<template lang="pug">

  .container(v-loading="pageLoading")
    .block-typical
      el-form.flex-form(
      ref='productForm'
      v-if="inputs.length"
      :model='stateForm'
      :rules="rules")

        el-form-item(
        v-for="item in inputs"
        :key="item.id"
        v-if='item.name !== "photo"'
        :style="`${item.maxWidth ? `max-width:${item.maxWidth};` : ''} ${ item.minWidth ? `min-width:${item.minWidth};` : '' } margin-bottom: 35px`"
        :prop="item.name")
          app-input(
          :placeholder="item.placeholder"
          :model="stateForm[item.name]"
          :name="item.name"
          :id="item.id"
          :label="item.label"
          :type="item.type"
          :prompt="item.prompt"
          :autosize="item.autosize"
          :required="item.required"
          :maxlength="item.maxlength"
          :options='options'
          :imageUploadView='false'
          :toolbarConfig='toolbarConfig'
          @input-value="modelValue")

        el-form-item(
          prop='photo'
          style='min-width: 100%')

          app-uploader(
            label="Фото"
            :uploadForm="uploadForm"
            :uploadFormHost="uploadFormHost"
            :readyToShip='readyToShip'
            @success-upload="successUpload"
            @change-photo="changePhoto")

    .activity__block.reverse
      .activity__block-wrapper
        h5 Активность:
        el-switch(
        v-model='productActive'
        active-color="#39D24E"
        :active-value='true'
        :inactive-value='false')

    .activity__block
      router-link.el-button.el-button--info.button(
      :to="{path: '/admin/products'}")
        |Отмена

      el-button.button(
      type="success"
      @click="createNews('productForm')")
        |Создать товар

</template>

<script>
import InputItem from '../../../components/InputItem';
import Uploader from '../../../components/admin/Uploader';

export default {
  layout: 'admin',
  name: 'NewProduct',
  components: {
    'app-input': InputItem,
    'app-uploader': Uploader
  },
  async asyncData(app) {
    let { data } = await app.$axios.get('/api/v1/categories/product?id=-1');
    return { categories: data };
  },
  data() {
    return {
      readyToShip: false,
      uploadFormHost: `${this.$store.state.baseURL}/api/v1/img`,
      uploadForm: {
        path: ''
      },
      options: [],
      inputs: [
        {
          id: 1,
          placeholder: 'Укажите наименование товара',
          model: '',
          label: 'Наименование товара',
          name: 'name',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 2,
          placeholder: 'Укажите состав товара',
          model: '',
          label: 'Состав',
          name: 'composition',
          type: 'textarea',
          autosize: { minRows: 1, maxRows: 20 },
          required: true,
          minWidth: '100%',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 3,
          placeholder: 'Укажите описание товара',
          model: '',
          label: 'Описание товара',
          name: 'description',
          type: 'editor',
          required: true,
          minWidth: '100%',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 4,
          placeholder: '',
          model: '',
          label: 'Белки',
          name: 'squirrels',
          type: 'text',
          minWidth: ''
        },
        {
          id: 5,
          placeholder: '',
          model: '',
          label: 'Жиры',
          name: 'fat',
          type: 'text',
          minWidth: ''
        },
        {
          id: 6,
          placeholder: '',
          model: '',
          label: 'Углеводы',
          name: 'carbohydrates',
          type: 'text',
          minWidth: ''
        },
        {
          id: 7,
          placeholder: '',
          model: '',
          label: 'Энергетическая ценность',
          name: 'energy',
          type: 'text'
        },
        {
          id: 11,
          placeholder: '',
          model: '',
          label: 'Категория товара',
          name: 'category',
          type: 'select',
          required: true,
          maxWidth: 320,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, выберите категорию',
              trigger: 'change'
            }
          ],
          maxWidth: 320
        },
        {
          id: 12,
          placeholder: 'Укажите ссылку на картинку',
          model: '',
          label: 'Картинка',
          name: 'photo',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, добавьте картинку',
              trigger: 'change'
            }
          ]
        },
        {
          id: 13,
          placeholder: '',
          model: '',
          label: 'Cортировка',
          name: 'sort',
          type: 'sort',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, укажите параметры сортировки',
              trigger: 'change'
            }
          ]
        }
      ],
      toolbarConfig: this.$store.state.toolbarNotPhotoVideo,
      pageLoading: false,
      productActive: true
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        state[item.name] = item.model;
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', [
      {
        name: 'Каталог товаров',
        slug: '/admin/products'
      }
    ]);
    this.$store.commit('headingTitle', 'Cоздание товара');
    this.$store.commit('publicLink', '');
    this.$store.commit('id', '');
  },
  mounted() {
    this.categories.forEach(item => {
      this.options.push({
        label: item.name,
        value: item.slug
      });
    });
  },
  methods: {
    changePhoto(value) {
      let index = this.inputs.findIndex(item => item.name === 'photo');
      this.inputs[index].model = value;
    },
    successUpload(response) {
      if (response.photo) {
        this.$axios
          .post('/api/v1/products/', {
            name: this.stateForm.name,
            composition: this.stateForm.composition,
            description: this.stateForm.description,
            category: this.stateForm.category,
            sort: this.stateForm.sort,
            squirrels: this.stateForm.squirrels,
            fat: this.stateForm.fat,
            carbohydrates: this.stateForm.carbohydrates,
            energy: this.stateForm.energy,
            photo: response.photo,
            active: this.productActive
          })
          .then(
            () => {
              this.pageLoading = false;
              this.$router.push('/admin/products');
              this.$message.success('Товар успешно добавлен!');
            },
            errorMessage => {
              console.log(errorMessage);
              this.$message.error('Ошибка перезаписи данных!');
              this.pageLoading = false;
            }
          )
          .catch(() => {
            this.$message.error('Ошибка перезаписи данных');
            this.pageLoading = false;
          });
      }
    },
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      this.inputs[index].model = valueArr[1];
    },
    createNews(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.uploadForm.path = `products/${this.stateForm.category}`;
          this.pageLoading = true;
          this.readyToShip = true;
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
